use Data_structure
use Constants
use initialization_lib
use Timestep
use Output
use Output_fluid
use debug
use bolsig_data
!include 'mpif.h'
!use MPI
!use Library_MPI

integer i,t1,t2
double precision test

call Set_initclock()
call Set_input()
call Set_init()
!call update_stencil()
!call update_stencil_Helm()

Time=0.d0
write(*,*) 'Computing time=',Time_end
call outputmaterial()
call output_meshgrid()

do i=1,1000000000
    call SYSTEM_CLOCK(t1)
    call NSSkin_Timestep_synchronous(Time,dTime,i)
    call SYSTEM_CLOCK(t2)
    !Time_use(5)=(t2-t1)/1.d4
    !call output_timecost()
!*********************************************************below is output*************************************************
!output the fixed point's information
        if (mod(i,10).eq.1)then
            call output_voltage()
            ifixed=1
        end if
        if (mod(i,50).eq.1) then ! debug mode
		    call output_density_debug(1)
            call output_Efield_debug()
        end if

        if (ipower.eq.1) then
            if (Time>Timerecorder) then ! full set output mode, output every interval time defined in global module
                call output_density(1)
                !call output_density(11)
                call output_Efield_vector()
                !call output_states_fluid()
                Timerecorder=Timerecorder+output_interval
                Timerecorder_fluid=Timerecorder
                N_output=N_output+1
				call output_current_electrode(2)
                call output_current_electrode(3)
            else if (Time>=Time_end) then
                call output_totalenergy_couple()
                call output_FGHenergy_couple()
                ipower=0
            end if
        else if (ifluid.eq.1) then
            if (Time>Timerecorder_fluid) then
			    !call output_states_fluid()
                Timerecorder_fluid=Timerecorder_fluid+1.d-7
                N_output=N_output+1
            else if (Time>Time_end_fluid) then
                write (*,*) 'calculate to the end, Time=',Time
                write (*,*) 'press enter to continue calculate, otherwise close the program mannually.'
                call Get_clock()
                stop
            end if
        else
            write (*,*) 'calculate to the end, Time=',Time
            write (*,*) 'press enter to continue calculate, otherwise close the program mannually.'
            call Get_clock()
            stop
        end if

    end do

    end
    
    
    
    !data input/12,24,23,123,34,131,45,1312,57,1,65,111,73,131231312/
    !call Interp_1D_linear(input,7,-999d0,result)